from telegram.ext import Updater, CommandHandler
from telegram import InputMediaPhoto, InputMediaVideo
from bs4 import BeautifulSoup
import requests
import hashlib
from datetime import datetime, timedelta
import pymysql.cursors

TOKEN = '62356235048256:AAEi3BDuhjyxUqTDuKAOLWUU6azOcMf9WXQ'
CHANNEL_ID = '@lafpersian'
ORIGINAL_WORD = '🆔 @GizmizTel 💯'
REPLACEMENT_WORD = '@lafpersian'

# اطلاعات اتصال به پایگاه داده
connection = pymysql.connect(host='localhost',
                             user='alirez15_film',
                             password='Mohammadi@1371',
                             database='alirez15_film',
                             charset='utf8mb4',
                             cursorclass=pymysql.cursors.DictCursor)

previous_links_hashes = []
has_new_post = False

def save_link(link, post_text):
    post_hash = hashlib.sha256(post_text.encode()).hexdigest()
    try:
        with connection.cursor() as cursor:
            # اضافه کردن متن پست به پایگاه داده
            sql = "INSERT INTO posts (link, post_text) VALUES (%s, %s)"
            cursor.execute(sql, (link, post_text))
        connection.commit()
    except Exception as e:
        print("Error saving link to database:", e)

def get_previous_links():
    previous_links = []
    try:
        with connection.cursor() as cursor:
            # دریافت لینک‌های پست‌های قبلی از پایگاه داده
            sql = "SELECT link FROM posts"
            cursor.execute(sql)
            result = cursor.fetchall()
            for row in result:
                previous_links.append(row['link'])
    except Exception as e:
        print("Error fetching previous links from database:", e)
    return previous_links

def fetch_and_send_posts(context):
    global has_new_post
    now = datetime.now()
    current_hour = now.hour
    
    if current_hour >= 9 and current_hour < 24 and not (current_hour >= 1 and current_hour < 8):
        url = 'https://t.me/s/gizmiztel'
        response = requests.get(url)
        if response.status_code == 200:
            soup = BeautifulSoup(response.text, 'html.parser')
            posts = soup.find_all('div', class_='tgme_widget_message')
            for post in posts:
                link = post.find('a')['href']
                post_text = post.find('div', class_='tgme_widget_message_text').text.strip()
                if ORIGINAL_WORD in post_text:
                    updated_post_text = post_text.replace(ORIGINAL_WORD, '')
                    updated_post_text += f"\n\n{' ' * 2}\n{REPLACEMENT_WORD}"
                    post_hash = hashlib.sha256(updated_post_text.encode()).hexdigest()
                    if post_hash not in previous_links_hashes:
                        previous_links_hashes.append(post_hash)
                        save_link(link, updated_post_text)
                        image_tag = post.find('div', class_='tgme_widget_message_photo_wrap')
                        if image_tag:
                            image_link = image_tag.find('img').get('data-src')
                            context.bot.send_photo(chat_id=CHANNEL_ID, photo=image_link, caption=updated_post_text)
                            has_new_post = True
                            return
                        video_tag = post.find('video')
                        if video_tag:
                            video_link = video_tag.get('src')
                            context.bot.send_video(chat_id=CHANNEL_ID, video=video_link, caption=updated_post_text)
                            has_new_post = True
                            return

    remaining_time = 0
    current_minute = now.minute
    remaining_time = (30 - current_minute) % 30
    if has_new_post:
        remaining_time = 0

    return remaining_time

def check_bot_status(update, context):
    global has_new_post
    remaining_time = fetch_and_send_posts(context)
    if remaining_time == 0:
        has_new_post = False
        next_post_time = datetime.now() + timedelta(hours=1)
        message = f"زمان باقی مانده تا ارسال پست بعدی: {next_post_time.strftime('%Y-%m-%d %H:%M:%S')}"
    else:
        message = f"زمان باقی مانده برای ارسال پست جدید: {remaining_time} دقیقه."
    
    context.bot.send_message(chat_id=update.effective_chat.id, text=message)

def schedule_job(context):
    fetch_and_send_posts(context)

def main():
    global previous_links_hashes
    previous_links_hashes = get_previous_links()
    
    updater = Updater(TOKEN, use_context=True)
    dp = updater.dispatcher
    dp.add_handler(CommandHandler("fetch", fetch_and_send_posts, pass_job_queue=True))
    updater.job_queue.run_repeating(fetch_and_send_posts, interval=2000, first=0, context=None)
    dp.add_handler(CommandHandler("status", check_bot_status))
    updater.start_polling()

    updater.idle()

    # بستن اتصال به پایگاه داده بعد از اتمام برنامه
    connection.close()
    
    # اتصال مداوم با تلگرام
    while True:
        try:
            updater.start_polling()
            break
        except Exception as e:
            print("Error starting the bot:", e)
            time.sleep(5)  # توقف برای چند ثانیه و سپس تلاش دوباره
            
if __name__ == '__main__':
    main()
